//+------------------------------------------------------------------
//|                                             MACD forr AUDUSD.mq5 
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#include <Trade\Trade.mqh>

input int    FastMACDPeriod   = 12;  // MACD fast period
input int    SlowMACDPeriod   = 26;  // MACD slow period
input int    SignalMACDPeriod =  9;  // MACD signal period
input double Lots             = 0.1; // Lots to trade (if fixed lots size used)
input double Risk             =  0;  // Rsik % (if variable lots size used)
input double StopLossPips     = 40;  // Stop loss in pips 
input double RiskRewardRatio  = 3.0; // Risk reward ratio
input int    StartHour        = 5;   // Start trading after (hour)
input int    EndingHour       = 15;  // End trading before (hour)

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int OnInit()
{
   return(0);
}
void OnDeinit(const int reason)
{
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing  0
#define _doOpenBuy  1
#define _doOpenSell 2

void OnTick()
{
   if(PositionSelect(_Symbol)) ManageOpened();
   else                        CheckForOpen();
}

//
//
//
//
//

void ManageOpened()
{
}
void CheckForOpen()
{
   int doWhat = checkEntry(); if (doWhat==_doNothing) return;

   //
   //
   //
   //
   //
   
      int    digits = (int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
      double point  = (double)SymbolInfoDouble(_Symbol,SYMBOL_POINT);
      double pip    = point; if (digits==3 || digits==5) pip = point*10.0;

      //
      //
      //
      //
      //
            
                  
      ENUM_ORDER_TYPE signal;
      if (doWhat==_doOpenBuy)  signal = ORDER_TYPE_BUY;
      if (doWhat==_doOpenSell) signal = ORDER_TYPE_SELL;
      if (TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
      {
         double sl,tp,bp;
            if (doWhat==_doOpenBuy)
            {
               bp = (double)SymbolInfoDouble(_Symbol,SYMBOL_ASK);
               sl = bp-StopLossPips*pip;
               tp = bp+StopLossPips*pip*RiskRewardRatio;
            }
            if (doWhat==_doOpenSell)
            {
               bp = (double)SymbolInfoDouble(_Symbol,SYMBOL_BID);
               sl = bp+StopLossPips*pip;
               tp = bp-StopLossPips*pip*RiskRewardRatio;
            }
      
            //
            //
            //
            //
            //
            
         CTrade trade;
                trade.PositionOpen(_Symbol,signal,getLots(Lots,Risk,StopLossPips*pip),SymbolInfoDouble(_Symbol,signal==ORDER_TYPE_SELL ? SYMBOL_BID:SYMBOL_ASK),sl,tp);
      }
}

//
//
//
//
//

int checkEntry()
{
   if (PositionSelect(_Symbol)) return(_doNothing);

   //
   //
   //
   //
   //
   
   MqlDateTime ct; TimeToStruct(TimeCurrent(),ct);
   static int macdHandle = 0;
          if (macdHandle == 0) macdHandle = iMACD(_Symbol,_Period,FastMACDPeriod,SlowMACDPeriod,SignalMACDPeriod,PRICE_CLOSE);
          if (macdHandle == INVALID_HANDLE) return(_doNothing);
          
          //
          //
          //
          //
          //
          
          double macdMain[3],macdSign[3];
          bool allowedHours =  (ct.hour>StartHour && ct.hour<EndingHour);
               if (!allowedHours)                                      return(_doNothing);
               if (CopyBuffer(macdHandle,0,0,3,macdMain)!=3)           return(_doNothing);
               if (CopyBuffer(macdHandle,1,0,3,macdSign)!=3)           return(_doNothing);
               if (macdMain[0]<macdSign[0] && macdMain[1]>macdSign[1]) return(_doOpenBuy);
               if (macdMain[0]>macdSign[0] && macdMain[1]<macdSign[1]) return(_doOpenSell);
                                                                       return(_doNothing);
}

//----------------------------------------------------------------------------------------
//                                 
//----------------------------------------------------------------------------------------
//
//
//
//
//
//
//

double getLots(double BaseLot, double risk, double stopLossDistance)
{
   double TickValue = SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE);
   double MinLots   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN) ,2);
   double MaxLots   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX) ,2);
   double LotStep   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP),2);
   double lots      = BaseLot;
   int    LotDigit;

      if (LotStep==1)    LotDigit=0;
      if (LotStep==0.1)  LotDigit=1;
      if (LotStep==0.01) LotDigit=2;
      if (risk>0 && stopLossDistance>0)
      {
         if (AccountInfoDouble(ACCOUNT_BALANCE)>AccountInfoDouble(ACCOUNT_FREEMARGIN))
               lots = NormalizeDouble(AccountInfoDouble(ACCOUNT_FREEMARGIN)*(risk/100.0)/(stopLossDistance*TickValue/_Point),LotDigit);
         else  lots = NormalizeDouble(AccountInfoDouble(ACCOUNT_BALANCE)   *(risk/100.0)/(stopLossDistance*TickValue/_Point),LotDigit);
      }      
   return(MathMax(MathMin(lots,MaxLots),MinLots));   
}

